﻿using UnityEngine;
using System.Collections;

public class Paper : MonoBehaviour {

	public static int maxPaperLevel = 1;

	public GameObject paper;
	public Canvas canvas;
	public UnityEngine.UI.Text contents;

	public float currentLength = 0;
	public float lastLength = 0.02f;
	public float lengthJump = 0.06f;
	public float printLength = 2;

	public float fixedLength = 0f;

	public bool printDone = false;

	public GameObject nextPaper;
	public GameObject nextPaper2;

	public void Start()
	{
		if (fixedLength != 0 || printLength > 0)
			this.SetDimensions(new Vector2(1, fixedLength));
	}

	public void SetDimensions(Vector2 dim)
	{
		this.paper.transform.localScale = new Vector3(dim.x, dim.y, 1);  // 556 / 1024
		this.canvas.GetComponent<RectTransform>().sizeDelta = new Vector2(dim.x * 208, dim.y * 380);
	}


	public void Update()
	{
		if (currentLength < printLength)
		{
			PrinterSound.inst.Play();

			this.rigidbody2D.isKinematic = true;
			this.GetComponent<Pipe>().canDrag = false;
			this.GetComponent<Pipe>().canRotate = false;

			currentLength += Time.deltaTime * 0.065f;
			if (currentLength - lastLength > lengthJump || currentLength < .03f)
			{
				this.SetDimensions(new Vector2(1, currentLength));
				this.transform.localPosition = new Vector3(0, currentLength*1.85f, 0);
				lastLength = currentLength;
			}
		
			if (currentLength >= printLength)
			{
				this.GetComponent<Pipe>().canDrag = true;
				this.GetComponent<Pipe>().canRotate = true;
				this.rigidbody2D.isKinematic = false;
				this.rigidbody2D.AddForce(new Vector2(0, 175));
				this.rigidbody2D.AddTorque(Random.Range(-5f, 5f));
				PrinterSound.inst.Stop();

				printDone = true;

				if (this.nextPaper != null && !this.nextPaper.activeSelf) 
				{
					this.nextPaper.SetActive(true);
				}
				if (this.nextPaper2 != null && !this.nextPaper2.activeSelf) 
				{
					this.nextPaper2.SetActive(true);
				}
			}
		}
	}

}
