﻿using UnityEngine;
using UnityEngine.EventSystems;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class RequestPipe : MonoBehaviour, IPointerClickHandler {

	public GameObject bottomBox;
	public GameObject pipes;

	public AudioClip bleep;

	public List<GameObject> pipePrefabs = new List<GameObject>();
	public List<GameObject> pipePrefabsEasy = new List<GameObject>();

	public GameObject joinPrefab;

	public IEnumerator DoClick()
	{
		Clock.ticking = true;

		AudioSource.PlayClipAtPoint(this.bleep, Camera.main.transform.position, 0.5f);

		yield return new WaitForSeconds(1);

		var prefabs = Clock.totalTime < 60 ? this.pipePrefabsEasy : this.pipePrefabs;

		var pipe = (GameObject.Instantiate(prefabs[Random.Range(0, prefabs.Count-1)]) as GameObject).GetComponent<Pipe>();
		pipe.transform.parent = pipes.transform;
		pipe.transform.position = bottomBox.transform.position + new Vector3(Random.Range(-1f, 1f), 0, 0);
		
		pipe.rigidbody2D.AddForce(new Vector2(0, Random.Range(2000, 5000)));
		pipe.rigidbody2D.AddTorque(Random.Range(-100, 100));
		
		if (Random.Range(0, 2) == 1)
		{
			// Add mirror pieces
			/*pipe.transform.localScale = Vector3.Scale(pipe.transform.localScale, new Vector3(-1, 1, 1));
				foreach (var c in pipe.GetComponentsInChildren<PipeConnector>())
				{
					if (Mathf.Approximately(c.transform.eulerAngles.z, 180)
					    || Mathf.Approximately(c.transform.eulerAngles.z, 0))
						c.transform.eulerAngles -= new Vector3(0, 0, 180);
				}
				*/
		}
		
		if (Random.Range(0, 3) != 1 && !pipe.gameObject.name.Contains("PipeJoin"))
		{
			var join = (GameObject.Instantiate(this.joinPrefab) as GameObject).GetComponent<Pipe>();
			join.transform.parent = pipes.transform;
			join.Start();
			pipe.Start();
			
			pipe.connectors.First().ConnectWith(join.connectors.First(), true);
		}
	}

	public void OnPointerClick(PointerEventData eventData)
	{
		if (eventData.pointerId == -1)
		{
			StartCoroutine(this.DoClick());
		}
	}
}
