﻿using UnityEngine;
using System.Collections;
using System.Linq;

public class ScheduledStream : MonoBehaviour {

	public Pipe startPipe;
	public Pipe endPipe;

	public float startTime;
	public float endTime;

	public ParticleSystem waterStream;
	public Paper paper;

	public Paper successPaper;

	public CentralBox centralBox;


	// Update is called once per frame
	void Update () 
	{
		if (Clock.totalTime > startTime && Clock.totalTime < endTime)
		{
			var otherEnd = this.startPipe.connectors.First().GetEnd();

			if (otherEnd.connectedTo != null)
			{
				// We're connected to another end!
				this.waterStream.gameObject.SetActive(false);

				if (this.successPaper == null && otherEnd.pipe == this.endPipe)
				{
					var print = (GameObject.Instantiate(this.centralBox.printPaperPrefab) as GameObject).GetComponent<Paper>();
					this.successPaper = print;
					print.transform.parent = this.centralBox.printSpawn.transform;
					print.transform.localPosition = Vector3.zero;
					print.contents.text = "";
					print.contents.text += "CONNECT RECEIVED\n";
					print.contents.text += "   REWARD SENT\n";
					print.printLength = 0.2f;
					print.contents.fontSize = 17;

					this.centralBox.ReleaseReward();
				}
			}
			else
			{
				// Open end
				if (this.waterStream.transform.parent != otherEnd.transform)
				{
					this.waterStream.transform.parent = otherEnd.transform;
					this.waterStream.transform.localPosition = Vector3.zero;
					var ang = this.waterStream.transform.localEulerAngles;
					ang.y = 90;
					this.waterStream.transform.localEulerAngles = ang;
				}
				this.waterStream.gameObject.SetActive(true);

				Water.AddWater(0.015f * Time.deltaTime);
			}
		}	
		else if (Clock.totalTime > endTime)
		{
			this.waterStream.emissionRate = 0;
			this.waterStream.GetComponent<AudioSource>().Stop();

			if (this.centralBox != null)
				this.centralBox.streams.Remove(this);
			Destroy(this.gameObject);
		}
	}
}
