﻿using UnityEngine;
using System.Collections;

public class Water : MonoBehaviour {

	static public float underWater = 0;

	public float zeroWater = -20.04f;
	public float topWater = -1.35f;

	public float waveStrength = 0f;
	public float currentWave = 0.1f;

	public Color baseColor;

	public static void AddWater(float water)
	{
		underWater += water;
	}

	public void Update()
	{
		if (underWater > 1)
			underWater = 1;
		if (underWater < 0)
			underWater = 0;

		var pos = this.transform.position;
		pos.y = (this.zeroWater + ((this.topWater - this.zeroWater) * underWater));
		this.transform.localPosition = pos;

		this.transform.eulerAngles += new Vector3(0, 0, this.currentWave) * Time.deltaTime;

		var angle = this.NormalizeAngle(this.transform.eulerAngles.z);

		if (angle > 2 || this.waveStrength == 0)
		{
			this.waveStrength = Random.Range(0.1f, 0.4f) * 10;
			this.currentWave = -this.waveStrength;
		}
		if (angle < -2)
		{
			this.waveStrength = Random.Range(0.1f, 0.4f) * 10;
			this.currentWave = this.waveStrength;
		}

		if (underWater == 0)
			this.transform.eulerAngles = Vector3.zero;

		if (underWater >= 1)
		{
			this.GetComponent<SpriteRenderer>().color -= new Color(0.3f * Time.deltaTime, 0.3f * Time.deltaTime, 0.3f * Time.deltaTime, -0.3f * Time.deltaTime);
		}
		else if (this.GetComponent<SpriteRenderer>().color != this.baseColor)
		{
			this.GetComponent<SpriteRenderer>().color += new Color(0.3f * Time.deltaTime, 0.3f * Time.deltaTime, 0.3f * Time.deltaTime, -0.3f * Time.deltaTime);
			if (this.GetComponent<SpriteRenderer>().color.a < this.baseColor.a)
				this.GetComponent<SpriteRenderer>().color = this.baseColor;
		}

		// Drain
		Water.AddWater(-0.01f * Time.deltaTime);
	}

	float NormalizeAngle(float angle)
	{
		float newAngle = angle;
		while (newAngle <= -180) newAngle += 360;
		while (newAngle > 180) newAngle -= 360;
		return newAngle;
	}
}
